# ===============================================================
#  == Zeroconf (IPOPT)                                          ==
#  ==                                                           ==
#  ==   Supplement of the work:                                 ==
#  ==                                                           ==
#  ==     Model Repair for probabilistic systems                ==
#  ==     E. Bartocci, R. Grosu, P. Katsaros,                   ==
#  ==     C.R. Ramakrishnan, Scott A. Smolka, TACAS 2011        ==
#  ==                                                           ==
#  ==   Authors of this file:                                   ==
#  ==                                                           ==
#  ==     E. Bartocci, P. Katsaros                              ==
#  ==                                                           ==
#  ==   Date:  07/07/10                                         ==
#  ==   Free distribution with authors permission               ==
#  ==                                                           ==
#  ==   SUNY Stony Brook, Stony Brook, NY                       ==
#  ==   Aristotle University of Thessaloniki, Greece            ==
#  ==                                                           ==
#  ===============================================================
# Knuth's model of a fair die using only fair coins
##############################################################################

# Definition of the variables with bounds
var q, >= 0, <= 1;

# objective function
# Uncomment the next 2 lines the model repair P<=1/8 F[s=7 & d=1] with 
# cost function min v1^2 + v2^2 + v3^2    Figure 3 a
minimize obj:
  v[1]^2 + v[2]^2 + v[3]^2;

#Uncomment the next 3 lines the model repair P<=1/8 F[s=7 & d=1] with 
#cost function min 10 * v1^2 + 5 * v2^2 + v3^2    Figure 3 b
#minimize obj:
#  10 * v[1]^2 + 5 * v[2]^2 + v[3]^2;

# and the constraints
subject to c1:
  (8*v[2]*v[3]*v[1] +4*v[2]*v[3] -4*v[2]*v[1] -2*v[2] +4*v[3]*v[1] +2*v[3] -2*v[1] -1) / (8*v[2]*v[3] +4*v[2] +4*v[3] -6) <= 1/8;


# Now we set the starting point:

let v[1] := 0;
let v[2] := 0;
let v[3] := 0;

